program Dimenzovanie_polovodicovych_usmernovacich_diod_v_mostikovom_zapojeni_s_protinapatim;

{$M $4000,$1000,$1000}

{$N+,E-,G+,F+,A+,R-,S-,I-,D+}

{$IFDEF WINDOWS}
Uses WinDos,WinCrt,NPU_387;
{$ELSE}
Uses Dos,Crt,NPU_387;
{$ENDIF}

var     U2,Ub           : xfloat;
        Fi,Psi,Alfa     : xfloat;
        Rp,Rb           : xfloat;
        Id,Ivav,Ief     : xfloat;

Const   Cele            : byte = $03;
        Desat           : byte = $02;

procedure Centruj_Text(Text:string; Riadok:byte);
begin
     GotoXY(Round((40-(Length(Text))/2)),Riadok);
     WriteLn(Text);
end;

procedure Vypocet;
var Odmocnina : xfloat;
begin
     Odmocnina:=FSqrt(2,2);
     Fi:=FArcCos(Ub/(Odmocnina*U2));
     Alfa:=(FPI/2)-Fi;
     Psi:=2*Fi;
     Id:=2*((Odmocnina*U2*FSin(FArcCos(Ub/(Odmocnina*U2))))-(Ub*(FArcCos(Ub/(Odmocnina*U2)))))/(FPI*(Rp+Rb));
     Ivav:=Id/2;
     Ief:=Ivav*FSqrt(FPI/Psi,2);
     WriteLn('Id       = ',Id:Cele*2:Desat,' A');
     WriteLn('Ivav     = ',Ivav:Cele*2:Desat,' A');
     WriteLn('Ief      = ',Ief:Cele*2:Desat,' A',' *');
     WriteLn('Alfa     = ',Alfa:Cele:Desat,' rad',' = ',FradDeg(Alfa):Cele:Desat,'');
     WriteLn('Psi      = ',Psi:Cele:Desat,' rad',' = ',FradDeg(Psi):Cele:Desat,'',' *');
     WriteLn('Fi       = ',Fi:Cele:Desat,' rad',' = ',FradDeg(Fi):Cele:Desat,'');
end;

procedure Vstup;
begin
     Write('U2 [V]   = '); Read(U2);
     Write('Ub [V]   = '); Read(Ub);
     Write('Rb [Ohm] = '); Read(Rb);
     Write('Rp [Ohm] = '); Read(Rp);
     WriteLn;
     WriteLn('--------------------------------');
     WriteLn;
     Vypocet;
     WriteLn;
     WriteLn('--------------------------------');
end;

begin
     ClrScr;
     Centruj_Text('Ing. Eduard Jadron, Jilemnickeho 37/46, 036 01 Martin',0);
     WriteLn;
     Centruj_Text('Program vypocita efektivnu hodnotu prudu Ief pre spravne dimenzovanie prvku.',3);
     Centruj_Text('----------------------------------------------------------------------------',4);
     WriteLn;
     Vstup;
end.